#####################################################
# E-Blah Bulliten Board Systems  -  Platinum Series #
#####################################################
# Copyright (c) 2001 - 2006 E-Blah.                 #
#####################################################

require("$language/Load.lng");

# Quick errors for restricted areas
sub is_admin  { error("$ltxt[1]-admin-",1) if(!$members{'Administrator',$username}); }
sub is_mod    { error($ltxt[2]) if(!$members{'Administrator',$username} && !$ismod); }
sub is_member {
	if(!$settings[23]) { return(); }
	elsif($settings[23] eq 'ADMIN') { error("$ltxt[24] $ltxt[26]"); }
	elsif($settings[23] eq 'EMAIL') { error("$ltxt[24] $ltxt[25]"); }
	elsif($settings[23] eq 'EMAIL|ADMIN') { error("$ltxt[24] $ltxt[27]"); }
		else { error($ltxt[23]); }
}

sub BoardCheck {
	my($bfnd,$nump,$t);

	fopen(FILE,"$boards/bdscats.db");
	@catbase = <FILE>;
	fclose(FILE);
	chomp @catbase;

	fopen(FILE,"$boards/bdindex.db");
	@boardbase = <FILE>;
	fclose(FILE);
	chomp @boardbase;

	if($URL{'b'} eq '' && $URL{'m'} ne 'latest' && ($URL{'v'} eq '' || $URL{'v'} eq 'print') && $URL{'m'} ne '') {
		foreach(@boardbase) {
			($boardid) = split("/",$_);

			if($URL{'b'} ne '') { last; }

			fopen(FILE,"$boards/$boardid.msg");
			while($t = <FILE>) {
				chomp $t;
				($id,$msub) = split(/\|/,$t);
				if($id eq $URL{'m'}) { $URL{'b'} = $boardid; last; }
			}
			fclose(FILE);
		}
		$scripturl = "$scriptname$modrewrite\lb-$URL{'b'}$usert";

		$activeusers = '';
	}

	return() if($URL{'b'} eq '');

	foreach(@boardbase) {
		($boardid,$binfo[0],$binfo[1],$binfo[2],$binfo[3],$binfo[4],$binfo[5],$binfo[6],$binfo[7],$binfo[8],$binfo[9],$binfo[10],$binfo[11],$binfo[12],$binfo[13],$binfo[14],$binfo[15]) = split("/",$_);
		if($boardid eq $URL{'b'}) { $bfnd = 1; last; }
	}

	error($ltxt[5],0,1) if !$bfnd;

	if($binfo[12] ne '') { # This board redirects, increase hits and exit
		fopen(ADD,"+<$boards/$URL{'b'}.hits");
		$nump = <ADD> || 0;
		seek(ADD,0,0);
		truncate(ADD,0);
		print ADD $nump+1,"\n";
		fclose(ADD);

		$binfo[12] =~ s/&#47;/\//g;
		redirect($binfo[12]);
	}

	# Lets start applying board permissions ...
	@mods = split(/\|/,$binfo[1]);
	foreach (@mods) {
		if($_ =~ /\((.+?)\)/ && $members{$1,$username}) { $ismod = 1; } # Member Group Mods
		if($username eq $_) { $ismod = 1; last; }
	}

	foreach (@catbase) {
		($nme,$id,$grps,$input) = split(/\|/,$_);
		if($input ne '') { @cats = split("/",$input); } else { next; }
		foreach (@cats) {
			if($_ eq $URL{'b'}) { $catid = $id; $catname = $nme; $memgrp = $grps; last; }
		}
	}

	push(@mgaccess,(split(',',$binfo[9]),split(',',$memgrp)));
	if(!GetMemberAccess($memgrp) || !GetMemberAccess($binfo[9])) { error($ltxt[5]); }

	if($binfo[6] ne '') { CoreLoad('BoardLock'); Password(); }
	if($binfo[10]) { $allowrate = 1; }

	$boardnm = $binfo[2];
}

sub Mods {
	$modz = '';
	foreach(@mods) {
		if($_ =~ /\((.+?)\)/ && $permissions{$1,'name'} ne '') { $modz .= qq~<a href="$surl\lv-members/a-groups/group-$1/">$permissions{$1,'name'}</a>, ~; }
			else {
				loaduser($_);
				if($userset{$_}->[1] eq '') { next; }
				$modz .= "$userurl{$_}, ";
			}
	}
	if($modz eq '') { return(); }
	$modz =~ s/, \Z//gi;
}

sub loaduser {
	my($user,$coloruser) = $_[0];   # DO NOT ADD LOADUSER TO MY STATEMENT!
	if($userset{$user}->[1] || $user eq '') { return(1); } # User is already loaded

	my $i = 0;
	fopen(LOADUSER,"$members/$user.dat") || return(0);
	while($luserdata = <LOADUSER>) {
		chomp $luserdata;
		if($i == 12 && (($hiddenmail == 2 && $username eq 'Guest') || ($hiddenmail == 1))) { $userset{$user}->[$i] = 1; ++$i; next; }
		$userset{$user}->[$i] = $luserdata;
		++$i;
	}
	fclose(LOADUSER);

	$userset{$user}->[1] = CensorList($userset{$user}->[1]);

	$coloruser = $permissions{$membergrp{$user},'color'} ? qq~<font color="$permissions{$membergrp{$user},'color'}"><b>$userset{$user}->[1]</b></font>~ : $userset{$user}->[1];
	$userurl{$user} = qq~<a href="$surl\lv-memberpanel/a-view/u-$user/" target="_parent">$coloruser</a>~;
}

sub StarCreator {
	my($starr);
	my($input) = @_;
	if($permissions{$input,'starcount'} < 1 || $permissions{$input,'starcount'} > 51) { $permissions{$input,'starcount'} = 1; }
	if($permissions{$input,'star'} eq '') { return(); }
	for($g = 0; $g < $permissions{$input,'starcount'}; $g++) { $starr .= qq~<img src="$images/$permissions{$input,'star'}">~; }
	return($starr);
}

sub loaduserdisplay {
	my($user) = $_[0];
	my($memberstar,$memberpic,$membericq,$memberaim,$membermsn,$memberpost,$ppd,$memberyim,$stpuser,$admintext);

	loaduser($user);
	$guest = 0;
	if($userset{$user}->[1] eq '') {
		$membername = CensorList($user);
		$membername =~ s/ \(Guest\)\Z//gis;
		$mprofile = qq~<div align="center">$gtxt{'0'}<br><br><br><br></div>~;
		$instmsg = '';
		$guest = 1;
		return;
	}

	if($divstart eq '') {
		$divstart = !$fancyqprofile ? ':</b> ' : qq~</b><div class="win" style="padding: 3px;">~;
		$divstop  = !$fancyqprofile ? '<br>' : '</div>';
	}

	$lastactive{$user} = get_date($userset{$user}->[28],1);

	# Get the group apart of, and stars ...
	$memberstar = $memberstat = $team = '';
	foreach(@grpsposts) {
		($num,$memgrp) = split(/\|/,$_);
		if($userset{$user}->[3] >= $num) {
			$memberstat = $permissions{$memgrp,'name'};
			$memberstar = StarCreator($memgrp);
		}
	}

	$permissions{$membergrp{$user},'level'} = $permissions{$membergrp{$user},'level'} <= 0 ? ($permissions{'Moderators','level'}+1) : $permissions{$membergrp{$user},'level'};
	foreach(@mods) {
		if($permissions{'Moderators','level'} && $user eq $_ && $permissions{$membergrp{$user},'level'} >= $permissions{'Moderators','level'}) {
			$membergrp{$user} = 'Moderators';
			last;
		}
	}

	if($membergrp{$user} ne '') {
		if($permissions{$membergrp{$user},'team'}) { $team = 1; }
		$memberstat = $permissions{$membergrp{$user},'name'};
		if($permissions{$membergrp{$user},'star'}) { $memberstar = StarCreator($membergrp{$user}); }
	}

	$membername = $userurl{$user};

	# Avatar
	if(!$settings[37] && $userset{$user}->[5] ne '' && $apic) {
		$pic = $userset{$user}->[5];
		if($userset{$user}->[35]) { ($height,$width) = split(/\|/,$userset{$user}->[35]); }
			else { $width = $picwidth; $height = $picheight; }
		if($userset{$user}->[5] =~ /http:/ || $userset{$user}->[32]) { $memberpic = qq~<img src="$pic" width="$width" height="$height">~; }
			else { $memberpic = qq~<img src="$avsurl/$userset{$user}->[5]">~; }
	}

	# E-mail address
	$memberemail = $userset{$user}->[12] && $hmail && !$members{'Administrator',$username} ? '' : qq~<a href="mailto:$userset{$user}->[2]">$img{'email'}</a>$msp2~;

	# Post count
	if(!$hideposts) { $memberpost = qq~<b style="line-height: 150%;">$ltxt[9]$divstart~.MakeComma($userset{$user}->[3]).$divstop; }

	# Instant Messanging
	if($userset{$user}->[9])  { $memberaim = qq~$msp2<a href="aim:goim?screenname=$userset{$user}->[9]&message=You+there?" title="$ltxt[10] ($userset{$user}->[9])">$img{'aim'}</a>~; }
	if($userset{$user}->[10]) { $membermsn = qq~$msp2<a href="http://members.msn.com/$userset{$user}->[10]" target="msn" title="$userset{$user}->[10]">$img{'msn'}</a>~; }
	if($userset{$user}->[8])  { $membericq = qq~$msp2<a href="http://www.icq.com/whitepages/wwp.php?to=$userset{$user}->[8]" target="icq" title="$userset{$user}->[8]">$img{'icq'}</a>~; }
	if($userset{$user}->[27]) { $memberyim = qq~$msp2<a href="http://profiles.yahoo.com/$userset{$user}->[27]" target="yim" title="$userset{$user}->[27]">$img{'yim'}</a>~; }

	if(!$settings[36] && $maxsig > 0 && $userset{$user}->[11]) { # Signature
		$message = $userset{$user}->[11];
		BC();
		$extra = qq~<tr><td><br><br></td></tr><tr><td valign="bottom" class="postbody"><div class="messageseps"><span class="smalltext">$message</span></div></td></tr>~;
	}
	if($showgender) { # Gender
		if($userset{$user}->[7] == 1) { $pic = "male"; $gen = $ltxt[11]; }
		elsif($userset{$user}->[7] == 2) { $pic = "female"; $gen = $ltxt[12]; }
		$gender = qq~<b>$ltxt[22]$divstart<img src="$images/$pic.gif"> $gen$divstop~;
		if(!$userset{$user}->[7]) { $gender = ''; }
	}
	if($sppd) { # Posts Per Day
		($t,$t,$t,$lday,$lmonth,$lyear,$lweek) = localtime($userset{$user}->[14]);
		($t,$t,$t,$cday,$cmonth,$cyear,$cweek) = localtime(time);
		$lyear = substr($lyear,-2);
		$cyear = substr($cyear,-2);
		++$lmonth; ++$cmonth;
		$reg = (365*$lyear)+(30.42*$lmonth)+$lday;
		$now = (365*$cyear)+(30.42*$cmonth)+$cday;
		$days = ($now-$reg) || 1;
		$ppd = sprintf(qq~<b>$ltxt[13]$divstart %.2f~, $userset{$user}->[3]/$days).$divstop;
	}
	if($enablerep) { # Reputation
		$reputation = '';
		if($userset{$user}->[43] ne '') {
			$color = '';
			if($userset{$user}->[43] < 50) { $color = 'redrep'; } # Horrible
			elsif($userset{$user}->[43] > 75) { $color = 'greenrep'; } # Best
				else { $color = 'grayrep'; } # Neut

			$reputation = qq~<b>$gtxt{'rep'}$divstart<span class="$color">$userset{$user}->[43]%</span>$divstop~;
		}
	}

	$avatar = $memberpic || $userset{$user}->[6] ? "$memberpic<br>$userset{$user}->[6]" : '';
	$showlocationu = $showlocation && $userset{$user}->[21] ne '' ? qq~<b>$ltxt[41]$divstart$userset{$user}->[21]$divstop~ : '';

	$memberstar = qq~<div>$memberstar</div>~ if $memberstar;

	if($team) { $memberstat = "<b>$memberstat</b>"; }
	$admintext = "<br>$userset{$user}->[4]" if $userset{$user}->[4];

	$memberstat = qq~<div style="line-height: 200%" align="center">$memberstat$admintext<br>$memberstar<br>$avatar</div><br>~ if($memberstat || $memberstar || $avatar);

	($t1,$t2) = split(/\|/,$userset{$user}->[45]);
	$timeon = '';
	if($showloggedon && ($t1 > 60)) {
		$days = '';
		$timeon = '';
		$days  = int($t1/86400);
		$hours = int($t1/3600)-($days*24);
		$mins  = int($t1/60)-(($hours+($days*24))*60);

		$days  = $days ? " $days $ltxt[43]" : '';
		$hours = $hours ? " $hours $gtxt{'3'}" : '';
		$mins  = $mins ? " $mins $gtxt{'2'}" : '';
		$timeon = qq~<b>$ltxt[42]$divstart$days$hours$mins$divstop~;
	}

	$mprofile = qq~$memberstat<div style="line-height: 140%; padding: 3px;" align="left">$gender$showlocationu$memberpost$ppd$timeon$reputation</div></span>~;
	$instmsg  = "$membericq$memberaim$memberyim$membermsn";
}

sub LogPage {
	if($username eq 'Guest') { return(); }
	my($lid,$ltime,$found,$lltime);

	$lltime = (time+2); # +2 prevents "Your New Post == New".

	fopen(ULOG,"$members/$username.log");
	while($log = <ULOG>) {
		chomp $log;
		($lid,$ltime) = split(/\|/,$log);
		$logged{$lid} = $ltime;
		$tempwrite .= "$log\n" if($lid ne $URL{'m'} && $lid ne $URL{'b'} && $ltime+($logdays*86400) > time);
	}
	fclose(ULOG);

	fopen(ULOG,"+>$members/$username.log");
	print ULOG "$URL{'m'}|$lltime\n" if($URL{'m'} ne '');
	if($_[0]) { $lltime = 0; }
	print ULOG "$URL{'b'}|$lltime\n$tempwrite";
	fclose(ULOG);
}

sub LMGS {
	if($members{'Administrator',$username}) { return(); }
	foreach(@fullgroups) {
		if($members{$_,$username}) {
			$ipon     = $permissions{$_,'ip'} || $ipon;
			$modon    = $permissions{$_,'moderate'} || $modon;
			$ston     = $permissions{$_,'sticky'} || $ston;
			$modifyon = $permissions{$_,'modify'} || $modifyon;
			$proon    = $permissions{$_,'profile'} || $proon;
			$calmod   = $permissions{$_,'cal'} || $calmod;
		}
	}
}

sub Ban {
	fopen(FILE,"$prefs/BanList.txt");
	while(<FILE>) {
		chomp $_;
		($banstring,$banlimit,$bantime) = split(/\|/,$_);
		$length = length($banstring);
		$ipsearch = substr($ENV{'REMOTE_ADDR'},0,$length);
		if($ipsearch =~ /\Q$banstring/i || $username eq $banstring || $banstring eq $settings[2]) { CoreLoad('BoardLock'); Banned($banlimit,$bantime); }
	}
	fclose(FILE);
}

sub FindRanks {
	my(@rdata);
	($frank) = $_[0];
	fopen(FILE,"$members/List.txt");
	@list = <FILE>;
	fclose(FILE);
	chomp @list;
	foreach(@list) {
		if($members{$frank,$_}) { push(@rdata,$_); }
	}
	return(@rdata);
}

sub Format {
	($temp) = $_[0];
	$temp =~ s/&/\&amp;/g;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	$temp =~ s/\cM//g;
	$temp =~ s/\n/<br>/g;
	$temp =~ s/\|/\&#124;/g;
	$temp =~ s/"/\&quot;/g;
	$temp =~ s/  /&nbsp;&nbsp;/gi;
	$temp =~ s/\t/&nbsp; &nbsp; &nbsp;/gi;
	return $temp;
}

sub Unformat {
	($temp) = $_[0];
	$temp =~ s/<br>/\n/g;
	$temp =~ s/&lt;/</g;
	$temp =~ s/&gt;/>/g;
	$temp =~ s/&nbsp; &nbsp; &nbsp;/\t/g; # DO THE TABS
	$temp =~ s/&nbsp;&nbsp;/  /gi;
	return $temp;
}

sub BoardProperties {
	$tallow = 0; # Thread rules start
	if($noguestp == 0 && $username eq 'Guest') { $rules .= $ltxt[30]; }
		else {
			if(GetMemberAccess($binfo[3])) { $rules .= $ltxt[31]; $tallow = 1; }
				else { $rules .= $ltxt[30]; }
		}
	if($noguestp == 0 && $username eq 'Guest') { $rules .= $ltxt[44]; }
		else {
			if(GetMemberAccess($binfo[4])) { $rules .= $ltxt[33]; $repallow = 1; }
				else { $rules .= $ltxt[44]; }
		}

	$rules .= (!GetMemberAccess($binfo[5]) || !$tallow) ? $ltxt[35] : $ltxt[34]; # Polls

	$rules .= ((($uallow eq 2 && $username ne 'Guest') || ($uallow eq 3 && $members{'Administrator',$username}) || ($uallow eq 1)) && GetMemberAccess($binfo[11])) ? $ltxt[29] : $ltxt[28];

	$rules2  = $ltxt[36];
	$rules2 .= $html ? $ltxt[37] : $ltxt[38];
	$rules2 .= $ltxt[39];
	$rules2 .= $BCLoad ? $ltxt[37] : $ltxt[38];
	$rules2 .= $ltxt[40];
	$rules2 .= $BCSmile ? $ltxt[37] : $ltxt[38];
}

sub ListBoards {
	if(!$boardbase[1]) { return(qq~<span class="smalltext">$boardnm ($ltxt[19])</span>~); }

	foreach(@catbase) {
		($t,$boardid,$memgrps,$t,$t,$subcats) = split(/\|/,$_);
		$catbase{$boardid} = $_;
		if(!GetMemberAccess($memgrps)) { next; }
		foreach(split(/\//,$subcats)) { $noshow{$_} = 1; }

		$cats .= "$boardid/";
	}

	foreach(@boardbase) {
		($id,$t,$t,$t,$t,$t,$t,$passed,$t,$t,$boardgood,$t,$t,$redir) = split("/",$_);
		if(!$members{'Administrator',$username} && (!GetMemberAccess($boardgood) || $passed ne '' || $redir ne '')) { next; }
		$board{$id} = $_;
	}

	$temp = qq~<script language="JavaScript">
<!--
function JumpTo(ghere) {
 if(ghere != '') { location = "$surl\lb-"+ghere+"/"; }
}
//-->
</script>
<select name="JumpZ" onChange="JumpTo(this.value);">~;

	$scat{"$URL{'b'}"} = ' selected';
	SubCatsList($cats,1);
	return($temp."</select>");
}

sub SubCatsList {
	foreach $catbased (split(/\//,$_[0])) {
		if($arshown{$catbased} || $catbase{$catbased} eq '') { next; }
		if($noshow{$catbased} && $_[1]) { next; }
		$arshown{$catbased} = 1;

		($b,$bid,$t,$input,$t,$subcats) = split(/\|/,$catbase{$catbased});

		$temp .= qq~<optgroup label="$_[2]$b">~;
		if($input ne '') {
			foreach $boardbased (split(/\//,$input)) {
				if($board{$boardbased} eq '') { next; }
				($obds,$t,$t,$info) = split("/",$board{$boardbased});
				$temp .= qq~<option value="$obds"$scat{$obds}>$_[2]$info</option>~;
			}
		}

		if($subcats ne '') { SubCatsList($subcats,0,"$_[2]&nbsp; &nbsp; "); }

		$temp .= "</optgroup>";
	}
}

sub FindStatus {
	my($temp);
	if($type) { $temp = 'locked'; }
	elsif($replies >= $vhtdmax) { $temp = 'veryhotthread'; }
	elsif($replies >= $htdmax) { $temp = 'hotthread'; }
		else { $temp = 'thread'; }
	if($poll && $type) { $temp = 'poll_lock'; }
	elsif($poll) { $temp = 'poll_icon'; }
	if($stickme{$messid} && $type && $temp ne 'poll_icon') { $temp = 'sticky_lock'; }
	elsif($stickme{$messid} && $temp eq 'poll_icon') { $temp = 'poll_sticky'; }
	elsif($stickme{$messid}) { $temp = 'sticky'; }
	return($temp);
}

sub CensorList {
	if($settings[39]) { return($_[0]); }

	if(!$CensorLoad) {
		fopen(CENSOR,"$prefs/Censor.txt");
		while($censor = <CENSOR>) {
			chomp $censor;
			@t = split(/\|/,$censor);
			if($t[0] ne '' && $t[1] ne '') {
				$CensorValues .= lc($t[0])."|";
				$Censor{lc($t[0])} = $t[1];
			}
		}
		fclose(CENSOR);
		$CensorValues =~ s/\|\Z//g;
		$CensorLoad = 1;
	}

	$_[0] =~ s/\b($CensorValues)\b/$Censor{lc($1)}/gi;

	return($_[0]);
}

sub BoardUsers {
	my(@usersonb,@userson);
	$cnt = 0;
	$gcnt = 0;
	fopen(FILE,"$prefs/Active.txt");
	@userson = <FILE>;
	fclose(FILE);
	chomp @userson;

	foreach(@userson) {
		($luser,$ltime,$hidden,$t,$bview) = split(/\|/,$_);
		loaduser($luser);
		if($userset{$luser}->[1] eq '') { $fndu = $luser; } else { $fndu = $userset{$luser}->[1]; }
		push(@usersonb,"$fndu|$luser|$hidden|$bview");
	}
	foreach(sort {lc($a) cmp lc($b)} @usersonb) {
		($trash,$luser,$hidden,$cbrd) = split(/\|/,$_);
		if($cbrd ne $URL{'b'}) { next; }
		if($userset{$luser}->[1] ne '') {
			if($hidden && !$members{'Administrator',$username}) { next; }

			$activeusers .= "$userurl{$luser}, ";
			++$cnt;
		} elsif($botsearch{$luser}) {
			$activeusers .= qq~<span class="onlinebots">$botsearch{$luser}</span>, ~;
			++$cnt;
		} else { ++$gcnt; }
	}

	$activeusers =~ s/, \Z//;
	if(!$activeusers) { $activeusers = $ltxt[20]; }
}

sub MakeSmall { # To make long code look like it's suppose to, do this ...
	if(!$BCLoad) { return; }
	$message =~ s/<(.[^">]*?)\Z//gsi;
	$message =~ s~\[(.[^\]]*?)\Z~~gsi;
	$message =~ s/<a href="(.[^">]*?)\Z//gsi;
	$message =~ s~\[code\](.*?)\Z~&Code~esgi;
	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[s\](.*?)\Z~<s>$1</s>~gsi;
	$message =~ s~\[b\](.*?)\Z~<b>$1</b>~gsi;
	$message =~ s~\[i\](.*?)\Z~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\Z~<u>$1</u>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\Z~<font size="$1">$2</font>~gsi;
	$message =~ s~\[pre\](.+?)\Z~<pre>$1</pre>~gsi;
	$message =~ s~\[justify\](.+?)\Z~<div align="justify">$1</div>~gsi;
	$message =~ s~\[left\](.+?)\Z~<div align="left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\Z~<div align="right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\Z~<center>$1</center>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\Z~<font face="$1">$2</font>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\Z~<font color="$1">$2</font>~gsi;
	$message =~ s~\[sub\](.+?)\Z~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\Z~<sup>$1</sup>~gsi;
	$message =~ s~\[img(.+?)\Z~~gsi;
	if($message =~ /\[list(.*?)\](.+?)\Z/) {
		$message =~ s~\[list\](.+?)\Z~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\Z~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}
}

sub GetMemberAccess { # Adapted from the BoardIndex =P
	my($grpaccess,$accessuser) = @_;
	my $boot = 1;
	if($accessuser eq '') { $accessuser = $username; }
	foreach $group (split(',',$grpaccess)) {
		if($members{$group,$accessuser}) { $boot = 0; }
		$boot = 0 if(($group eq 'member' && $settings[1] ne '') || ($group eq 'guest' && $accessuser eq 'Guest') || ($group eq 'validating' && $settings[1] eq '' && $accessuser ne 'Guest'));
	}
	if($boot) { return(0); }
	return(1);
}

sub CreateGroups { # Member Groups (Version 2)
	my(%groupmembers);

	fopen(FILE,"$prefs/Ranks2.txt");
	@globalgroups = <FILE>;
	fclose(FILE);
	chomp @globalgroups;

	foreach(@globalgroups) {
		if($_ =~ /(.+?) => {/) {
			$curread = $1;
			push(@fullgroups,$1);
		}
		elsif($_ eq '}') { $curread = ''; }

		if($curread) { # Get the permissions for this group
			if($_ =~ /(.+?) = '(.+?)'/) {
				$permissions{$curread,$1} = $2;

				if($1 eq 'pcount') { push(@grpsposts,"$2|$curread"); }
			}
			elsif($_ =~ /(.+?) = \((.+?)\)/) {
				if($1 eq 'members') {
					foreach $user (split(',',$2)) {
						$members{$curread,$user} = 1;
						if($permissions{$curread,'level'} > 0 && ($permissions{$curread,'level'} < $permissions{$membergrp{$user},'level'} || $membergrp{$user} eq '')) { $membergrp{$user} = $curread; }
						++$permissions{$curread,'count'};
					}
				}
				$permissions{$curread,$1} = $2;
			}
		}
	}
	@grpsposts = sort{$a <=> $b} @grpsposts;
	LMGS();
}
1;